///////////////////////////////////////////////////////////////////////////////
// Tyler Perkins
// 9-23-21
// stack implementation
//

#include "stack.h"

struct s_node* head = NULL;
unsigned int _head_error = 0;

void push(int val){
    struct s_node* temp;

    temp = head;
    head = (struct s_node*)malloc(sizeof(struct s_node));

    head->_val = val;
    head->_next = temp;
}

int pop(){
    struct s_node* temp;
    int retval;

    if(head == NULL){
        _head_error = POP_EMPTY_STACK;
        return 0;
    }

    temp = head;
    head = head->_next;

    retval = temp->_val;

    free(temp);

    return retval;
}

int peek(){
    if(head == NULL){
        _head_error = PEEK_EMPTY_STACK;
        return 0;
    }

    return head->_val;
}
